#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TelephoneBillDropCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TelephoneBillDropCFG> Fish_TelephoneBillDropCFG::msSingleton(nullptr);

int Fish_TelephoneBillDropCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TelephoneBillDropCFGData* Fish_TelephoneBillDropCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TelephoneBillDropCFGData>& Fish_TelephoneBillDropCFG::GetMapData()
{
	return mMapData;
}

void Fish_TelephoneBillDropCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TelephoneBillDropCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TelephoneBillDropCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRechargeLimit = element->IntAttribute("RechargeLimit");
		{
			const char* HistoricalCharges = element->Attribute("HistoricalCharges");
			std::vector<std::string> vecHistoricalCharges;
			boost::split(vecHistoricalCharges, HistoricalCharges, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecHistoricalCharges.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecHistoricalCharges[i].c_str(), &temp))
				{
					data.mHistoricalCharges.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TelephoneBillDropCFG::Load()
{
	Load("../Config/Fish_TelephoneBillDropCFG.xml");
}

Fish_TelephoneBillDropCFG* Fish_TelephoneBillDropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TelephoneBillDropCFG());
	}
	return msSingleton.get();
}
